;; $Id: plugin-example.lisp,v 1.3 2004/06/28 18:17:13 boelthorn Exp $
(def-xchat-plugin "ECL Example Plugin"
    :version "0.1"
    :description "Just a little fun stuff to demonstrate plugin interface")
    
;; A reverse polish calculator usable from IRC. (e.g. !compute 2 3 + )

(defun reverse-polish (arguments &optional stack)
  (if (null arguments)
      (pop stack)
  (let ((cmd (let ((*read-eval* nil))
;		   (*package* (find-package "XCHAT")))
	       (read-from-string (first arguments)))))
    (etypecase cmd
      (number (reverse-polish (rest arguments) (cons cmd stack)))
      (symbol (reverse-polish (rest arguments)
			      (cons
			       (flet ((rev-call (fun &rest arguments)
					(apply fun (nreverse arguments))))					
				 (ecase cmd
				   (+    (+ (pop stack) (pop stack)))
				   (*    (* (pop stack) (pop stack)))
				   (/    (rev-call #'/ (pop stack) (pop stack)))
				   (-    (rev-call #'- (pop stack) (pop stack)))
				   (ISQRT (isqrt (pop stack)))
				   (SQRT (sqrt (pop stack)))
				   (SHL  (rev-call #'ash (pop stack) (pop stack)))
				   (SHR  (rev-call #'ash (- (pop stack)) (pop stack)))))
			       stack)))))))

  
(%hook-channel-command *plugin* "!COMPUTE"
	#'(lambda (split word)
	    (handler-case
		(%commandf "MSG ~A Thus spake the Reverse Polish Calculator: ~A"
				(%get-info "channel")
				(reverse-polish (rest split)))
	      (t () (%commandf "MSG ~A The Reverse Polish Calculator refuses to answer due to an unknown reason."
			       (%get-info "channel"))))))

;; Fun commands

(defun random-nick ()
  (let ((users (%list-get :users)))
    (cdr (assoc :nick (elt users (random (length users)))))))

(defmacro xchat-delay ((delay) &body body)
  `(%hook-timer *plugin* ,delay
    #'(lambda ()
	,@body
	nil)))

(%hook-channel-command *plugin* "!ORDER"
	#'(lambda (split word)
	    (when (= 2 (length split))
	      (let ((drink (second split))
		    (chan  (%get-info "channel")))
		(xchat-delay (2000)
		  (%commandf "MSG ~A ~A orders a round of ~A."
			     chan (first word) drink))
		(xchat-delay (20000)
		  (if (zerop (random 5))
		      (%commandf "MSG ~A I see the waitress falter as she passes a table dropping all the ~A she carried over ~A."
				 chan drink (random-nick))
		      (%commandf "MSG ~A The waitress arrives and serves ~A."
				 chan drink)))))))

(%hook-channel-command *plugin* "!CHOOSE-PERSON"
		       #'(lambda (split word)
			   (%commandf "MSG ~A ~A is the chosen one."
				      (%get-info "channel")
				      (random-nick))))

