;;; $Id: plugin-fortune.lisp,v 1.4 2004/02/19 18:10:59 boelthorn Exp $
(def-xchat-plugin "Fortune Teller"
    :version "0.1"
    :description "Tell me a !fortune")

;;; If someone says !fortune in a channel you are on,
;;; this plugin calls fortune(1).

(defconstant +max-line+ 4)

(defmacro with-delay (delay &body body)
  `(progn
    (%hook-timer *plugin* ,delay
     #'(lambda ()
	 ,@body
	 nil))
    nil))

(defun pass-on (cmd fn)
  (let ((in (si:open-pipe cmd)))
    (when in
      (unwind-protect
	   (loop for line = (read-line in nil nil)
		 until (null line)
		 do (funcall fn line))
	   (close in)))))


(%hook-channel-command *plugin* "!FORTUNE"
		       #'(lambda (split word)
			   (with-delay 1
			     (block pass
			       (pass-on "fortune -as"
					(let ((count 0))
					  #'(lambda (line)
					      (cond
						((> (incf count) +max-line+)
						 (%commandf "MSG ~A ... truncated ... too long ..."
							    (%get-info "channel"))
						 (return-from pass))
						((not (zerop (length line)))
						 (%commandf "MSG ~A ~A"
							    (%get-info "channel") line))))))))))
			   	   
		 