;;; $Id: plugin-rot13.lisp,v 1.2 2004/02/19 18:10:59 boelthorn Exp $
(def-xchat-plugin "Rot13 Plugin"
    :version "0.1"
    :description "Ever wanted to encode your messages? :)")

;;; This script lets you use the (in)famous ROT13 shift to
;;; "encode" your messages, see below.

(defun caesar-shift (text n)
  "Rot13 is a special case of the Caesar shift."
  (coerce
   (loop for char across text
	 collect (if (alpha-char-p char)
		     (code-char
		      (let ((c-a (if (upper-case-p char)
				     (char-code #\A)
				     (char-code #\a))))
			(+ c-a
			   (mod (+ (- (char-code char) c-a) n) 26))))
		     char))
   'simple-base-string))

(defun say-rot (msg rot)
  (let ((enc (caesar-shift msg rot)))
    (%printf "Encoding '~A' (shifted by ~A)~%" msg rot)
    (%commandf "MSG ~A ~A" (%get-info "channel") enc)))


(defun cbRot13 (word word_eol)
  (say-rot (second word_eol) 13))

(defun cbRot (word word_eol)
  (say-rot (third word_eol) (parse-integer (second word))))

(defun cbDeRot13 (word word_eol)
  (%print (caesar-shift (second word_eol) 13)))

(defun cbDeRot (word word_eol)
  (%print (caesar-shift (third word_eol) (parse-integer (second word)))))

(%hook-command *plugin* "rot13" #'cbRot13 "Usage: /rot13 <msg> - Echoes encoded message to current channel.")
(%hook-command *plugin* "rot" #'cbRot "Usage: /rot count <msg> - Echoes encoded message to current channel.")
(%hook-command *plugin* "derot13" #'cbDeRot13 "Usage: /derot13 <msg> - Decodes message.")
(%hook-command *plugin* "derot" #'cbDeRot "Usage: /derot count <msg> - Decodes message.")